TransferQueue (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.util.concurrent, interface: TransferQueue
Keywords: java.util.concurrent.TransferQueue interface

# Interface TransferQueue<E>

Type Parameters:
  `E` - the type of elements held in this queue

All Superinterfaces:
  `BlockingQueue<E>, Collection<E>, Iterable<E>, Queue<E>`

All Known Implementing Classes:
  `LinkedTransferQueue`

public interface TransferQueue<E> extends BlockingQueue<E>
A `BlockingQueue` in which producers may wait for consumers to receive elements. A `TransferQueue` may be useful for example in message passing applications in which producers sometimes (using method `transfer(E)`) await receipt of elements by consumers invoking `take` or `poll`, while at other times enqueue elements (via method `put`) without waiting for receipt. Non-blocking and time-out versions of `tryTransfer` are also available. A `TransferQueue` may also be queried, via `hasWaitingConsumer()`, whether there are any threads waiting for items, which is a converse analogy to a `peek` operation.

Like other blocking queues, a `TransferQueue` may be capacity bounded. If so, an attempted transfer operation may initially block waiting for available space, and/or subsequently block waiting for reception by a consumer. Note that in a queue with zero capacity, such as `SynchronousQueue`, `put` and `transfer` are effectively synonymous.

This interface is a member of the Java Collections Framework.

Since:
  1.7

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getWaitingConsumerCount()`
  Returns an estimate of the number of consumers waiting to receive elements via `BlockingQueue.take()` or timed `poll`.
  `boolean`
  `hasWaitingConsumer()`
  Returns `true` if there is at least one consumer waiting to receive an element via `BlockingQueue.take()` or timed `poll`.
  `void`
  `transfer(E e)`
  Transfers the element to a consumer, waiting if necessary to do so.
  `boolean`
  `tryTransfer(E e)`
  Transfers the element to a waiting consumer immediately, if possible.
  `boolean`
  `tryTransfer(E e, long timeout, TimeUnit unit)`
  Transfers the element to a consumer if it is possible to do so before the timeout elapses.

  ### Methods declared in interface BlockingQueue

  `add, contains, drainTo, drainTo, offer, offer, poll, put, remainingCapacity, remove, take`
  Modifier and Type
  Method
  Description
  `boolean`
  `add(E e)`
  Inserts the specified element into this queue if it is possible to do so immediately without violating capacity restrictions, returning `true` upon success and throwing an `IllegalStateException` if no space is currently available.
  `boolean`
  `contains(Object o)`
  Returns `true` if this queue contains the specified element.
  `int`
  `drainTo(Collection<? super E> c)`
  Removes all available elements from this queue and adds them to the given collection.
  `int`
  `drainTo(Collection<? super E> c, int maxElements)`
  Removes at most the given number of available elements from this queue and adds them to the given collection.
  `boolean`
  `offer(E e)`
  Inserts the specified element into this queue if it is possible to do so immediately without violating capacity restrictions, returning `true` upon success and `false` if no space is currently available.
  `boolean`
  `offer(E e, long timeout, TimeUnit unit)`
  Inserts the specified element into this queue, waiting up to the specified wait time if necessary for space to become available.
  `E`
  `poll(long timeout, TimeUnit unit)`
  Retrieves and removes the head of this queue, waiting up to the specified wait time if necessary for an element to become available.
  `void`
  `put(E e)`
  Inserts the specified element into this queue, waiting if necessary for space to become available.
  `int`
  `remainingCapacity()`
  Returns the number of additional elements that this queue can ideally (in the absence of memory or resource constraints) accept without blocking, or `Integer.MAX_VALUE` if there is no intrinsic limit.
  `boolean`
  `remove(Object o)`
  Removes a single instance of the specified element from this queue, if it is present.
  `E`
  `take()`
  Retrieves and removes the head of this queue, waiting if necessary until an element becomes available.

  ### Methods declared in interface Collection

  `addAll, clear, containsAll, equals, hashCode, isEmpty, iterator, parallelStream, removeAll, removeIf, retainAll, size, spliterator, stream, toArray, toArray, toArray`
  Modifier and Type
  Method
  Description
  `boolean`
  `addAll(Collection<? extends E> c)`
  Adds all of the elements in the specified collection to this collection (optional operation).
  `void`
  `clear()`
  Removes all of the elements from this collection (optional operation).
  `boolean`
  `containsAll(Collection<?> c)`
  Returns `true` if this collection contains all of the elements in the specified collection.
  `boolean`
  `equals(Object o)`
  Compares the specified object with this collection for equality.
  `int`
  `hashCode()`
  Returns the hash code value for this collection.
  `boolean`
  `isEmpty()`
  Returns `true` if this collection contains no elements.
  `Iterator<E>`
  `iterator()`
  Returns an iterator over the elements in this collection.
  `default Stream<E>`
  `parallelStream()`
  Returns a possibly parallel `Stream` with this collection as its source.
  `boolean`
  `removeAll(Collection<?> c)`
  Removes all of this collection's elements that are also contained in the specified collection (optional operation).
  `default boolean`
  `removeIf(Predicate<? super E> filter)`
  Removes all of the elements of this collection that satisfy the given predicate (optional operation).
  `boolean`
  `retainAll(Collection<?> c)`
  Retains only the elements in this collection that are contained in the specified collection (optional operation).
  `int`
  `size()`
  Returns the number of elements in this collection.
  `default Spliterator<E>`
  `spliterator()`
  Creates a `Spliterator` over the elements in this collection.
  `default Stream<E>`
  `stream()`
  Returns a sequential `Stream` with this collection as its source.
  `Object[]`
  `toArray()`
  Returns an array containing all of the elements in this collection.
  `default <T> T[]`
  `toArray(IntFunction<T[]> generator)`
  Returns an array containing all of the elements in this collection, using the provided `generator` function to allocate the returned array.
  `<T> T[]`
  `toArray(T[] a)`
  Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array.

  ### Methods declared in interface Iterable

  `forEach`
  Modifier and Type
  Method
  Description
  `default void`
  `forEach(Consumer<? super E> action)`
  Performs the given action for each element of the `Iterable` until all elements have been processed or the action throws an exception.

  ### Methods declared in interface Queue

  `element, peek, poll, remove`
  Modifier and Type
  Method
  Description
  `E`
  `element()`
  Retrieves, but does not remove, the head of this queue.
  `E`
  `peek()`
  Retrieves, but does not remove, the head of this queue, or returns `null` if this queue is empty.
  `E`
  `poll()`
  Retrieves and removes the head of this queue, or returns `null` if this queue is empty.
  `E`
  `remove()`
  Retrieves and removes the head of this queue.

- ## Method Details

  - ### tryTransfer

    boolean tryTransfer(E e)
    Transfers the element to a waiting consumer immediately, if possible.

    More precisely, transfers the specified element immediately if there exists a consumer already waiting to receive it (in `BlockingQueue.take()` or timed `poll`), otherwise returning `false` without enqueuing the element.

    Parameters:
      `e` - the element to transfer
    Returns:
      `true` if the element was transferred, else `false`
    Throws:
      `ClassCastException` - if the class of the specified element prevents it from being added to this queue
      `NullPointerException` - if the specified element is null
      `IllegalArgumentException` - if some property of the specified element prevents it from being added to this queue

  - ### transfer

    void transfer(E e) throws InterruptedException
    Transfers the element to a consumer, waiting if necessary to do so.

    More precisely, transfers the specified element immediately if there exists a consumer already waiting to receive it (in `BlockingQueue.take()` or timed `poll`), else waits until the element is received by a consumer.

    Parameters:
      `e` - the element to transfer
    Throws:
      `InterruptedException` - if interrupted while waiting, in which case the element is not left enqueued
      `ClassCastException` - if the class of the specified element prevents it from being added to this queue
      `NullPointerException` - if the specified element is null
      `IllegalArgumentException` - if some property of the specified element prevents it from being added to this queue

  - ### tryTransfer

    boolean tryTransfer(E e, long timeout, TimeUnit unit) throws InterruptedException
    Transfers the element to a consumer if it is possible to do so before the timeout elapses.

    More precisely, transfers the specified element immediately if there exists a consumer already waiting to receive it (in `BlockingQueue.take()` or timed `poll`), else waits until the element is received by a consumer, returning `false` if the specified wait time elapses before the element can be transferred.

    Parameters:
      `e` - the element to transfer
      `timeout` - how long to wait before giving up, in units of `unit`
      `unit` - a `TimeUnit` determining how to interpret the `timeout` parameter
    Returns:
      `true` if successful, or `false` if the specified waiting time elapses before completion, in which case the element is not left enqueued
    Throws:
      `InterruptedException` - if interrupted while waiting, in which case the element is not left enqueued
      `ClassCastException` - if the class of the specified element prevents it from being added to this queue
      `NullPointerException` - if the specified element is null
      `IllegalArgumentException` - if some property of the specified element prevents it from being added to this queue

  - ### hasWaitingConsumer

    boolean hasWaitingConsumer()
    Returns `true` if there is at least one consumer waiting to receive an element via `BlockingQueue.take()` or timed `poll`. The return value represents a momentary state of affairs.
    Returns:
      `true` if there is at least one waiting consumer

  - ### getWaitingConsumerCount

    int getWaitingConsumerCount()
    Returns an estimate of the number of consumers waiting to receive elements via `BlockingQueue.take()` or timed `poll`. The return value is an approximation of a momentary state of affairs, that may be inaccurate if consumers have completed or given up waiting. The value may be useful for monitoring and heuristics, but not for synchronization control. Implementations of this method are likely to be noticeably slower than those for `hasWaitingConsumer()`.
    Returns:
      the number of consumers waiting to receive elements